# -*- coding: utf-8 -*-
"""
Created on Tue Apr 27 16:39:19 2021

@author: jansk
"""
import chess
import chess.pgn
import Chessnut


def binary_string_to_board_string(binary_string,previous_board_string):
    binary_string = binary_string[::-1]
    current_board_string = ''
    moved_piece = ''
    for i in range(len(previous_board_string)):
        if binary_string[i] == '0' and previous_board_string[i] == '0':
            current_board_string = current_board_string + '0'
        elif binary_string[i] == '0' and previous_board_string[i] != '0':
            current_board_string = current_board_string + '0'
            moved_piece = previous_board_string[i]
        elif binary_string[i] == '1' and previous_board_string[i] == '0':
            current_board_string = current_board_string + 'x'
        elif binary_string[i] == '1' and previous_board_string[i] != '0':
            current_board_string = current_board_string + previous_board_string[i]
    current_board_string = current_board_string.replace('x', str(moved_piece))
    return (current_board_string)


#function to change a FEN into a comparable format
def fen_to_board_string(fen):
    board_string=""
    for i in range(len(fen)):
        if fen[i] == "1":
            board_string = board_string + "0"
        if fen[i] == "2":
            board_string = board_string + "00"
        if fen[i] == "3":
            board_string = board_string + "000"
        if fen[i] == "4":
            board_string = board_string + "0000"
        if fen[i] == "5":
            board_string = board_string + "00000"
        if fen[i] == "6":
            board_string = board_string + "000000"
        if fen[i] == "7":
            board_string = board_string + "0000000"
        if fen[i] == "8":
            board_string = board_string + "00000000"
        if fen[i] == "r" or fen[i] == "n" or fen[i] == "b" or fen[i] == "q" or fen[i] == "k" or fen[i] == "p":
            board_string = board_string + fen[i]
        if fen[i] == "R" or fen[i] == "N" or fen[i] == "B" or fen[i] == "Q" or fen[i] == "K" or fen[i] == "P":
            board_string = board_string + fen[i]
        if fen[i] == " ":
            break #Break at the end of the pieces
    return board_string

def board_string_to_fen(board_string):
    board_fen=''
    em = 0
    k = 0
    for i in range(len(board_string)):
        if k < 8:
            if board_string[i] != '0':
                board_fen = board_fen + board_string[i]
            elif board_string[i] == '0':
                if board_string[i+1] == '0':
                    em = em + 1
                    if em == 8:
                        board_fen = board_fen + '8'
                        em = 0
                elif board_string[i+1] != '0':
                    em = em + 1
                    if em == 8:
                        board_fen = board_fen + '8'
                        em = 0
                    if em != 0:
                        board_fen = board_fen + str(em)
                        em = 0
            k = k + 1
        if k == 8:
            if em != 0:
                board_fen = board_fen + str(em)
            board_fen = board_fen + '/'
            em = 0
            k = 0
    board_fen = board_fen[:-1]
    return board_fen             
        
def move_from_fens(current_board_fen,previous_board_fen):
    previous_board_string = fen_to_board_string(previous_board_fen) #Store the board_string prior to the move as previous_board_string
    current_board_string = fen_to_board_string(current_board_fen)
    
    board = chess.Board(previous_board_fen)
    
    #Read the board_strings to compare differences before and after the move
    for i in range(64):
        if previous_board_string[i] != current_board_string[i]:
            p = previous_board_string[i]
            #if the changed position was not empty before we have found the piece that was moved
            if p != current_board_string[i]:
                from_square_index = 64-i
                from_square = chess.square_name(from_square_index) #Turn the square index into square name
                print(from_square)
                break #Break the loop when we have found the move
          
    chessgame = Chessnut.Game(previous_board_fen)
    legal_moves = chessgame.get_moves()
    print(legal_moves)
    for i in range(len(legal_moves)):
        if from_square in legal_moves[i]:
            test_move = chess.Move.from_uci(legal_moves[i])
            board.push(test_move)
            print(str(test_move))
            test_board_string = fen_to_board_string(board.fen())
            print(test_board_string)
            print(current_board_string)
            if test_board_string == current_board_string:
                #Note move to PGN
                move_str = str(test_move)
                previous_board_string = current_board_string
                break
            else:
                board.pop()
    return previous_board_string, move_str